// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.19.4
// source: api/grpc/proto/post.proto

package grpc

import (
	context "context"

	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// TristagrammClient is the client API for Tristagramm service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type TristagrammClient interface {
	GetPostsList(ctx context.Context, in *GetPostListRequest, opts ...grpc.CallOption) (*GetPostListResponse, error)
	GetPostsStream(ctx context.Context, in *GetPostListRequest, opts ...grpc.CallOption) (Tristagramm_GetPostsStreamClient, error)
}

type tristagrammClient struct {
	cc grpc.ClientConnInterface
}

func NewTristagrammClient(cc grpc.ClientConnInterface) TristagrammClient {
	return &tristagrammClient{cc}
}

func (c *tristagrammClient) GetPostsList(ctx context.Context, in *GetPostListRequest, opts ...grpc.CallOption) (*GetPostListResponse, error) {
	out := new(GetPostListResponse)
	err := c.cc.Invoke(ctx, "/Tristagramm/GetPostsList", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tristagrammClient) GetPostsStream(ctx context.Context, in *GetPostListRequest, opts ...grpc.CallOption) (Tristagramm_GetPostsStreamClient, error) {
	stream, err := c.cc.NewStream(ctx, &Tristagramm_ServiceDesc.Streams[0], "/Tristagramm/GetPostsStream", opts...)
	if err != nil {
		return nil, err
	}
	x := &tristagrammGetPostsStreamClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Tristagramm_GetPostsStreamClient interface {
	Recv() (*Post, error)
	grpc.ClientStream
}

type tristagrammGetPostsStreamClient struct {
	grpc.ClientStream
}

func (x *tristagrammGetPostsStreamClient) Recv() (*Post, error) {
	m := new(Post)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// TristagrammServer is the Server API for Tristagramm service.
// All implementations must embed UnimplementedTristagrammServer
// for forward compatibility
type TristagrammServer interface {
	GetPostsList(context.Context, *GetPostListRequest) (*GetPostListResponse, error)
	GetPostsStream(*GetPostListRequest, Tristagramm_GetPostsStreamServer) error
	mustEmbedUnimplementedTristagrammServer()
}

// UnimplementedTristagrammServer must be embedded to have forward compatible implementations.
type UnimplementedTristagrammServer struct {
}

func (UnimplementedTristagrammServer) GetPostsList(context.Context, *GetPostListRequest) (*GetPostListResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPostsList not implemented")
}
func (UnimplementedTristagrammServer) GetPostsStream(*GetPostListRequest, Tristagramm_GetPostsStreamServer) error {
	return status.Errorf(codes.Unimplemented, "method GetPostsStream not implemented")
}
func (UnimplementedTristagrammServer) mustEmbedUnimplementedTristagrammServer() {}

// UnsafeTristagrammServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to TristagrammServer will
// result in compilation errors.
type UnsafeTristagrammServer interface {
	mustEmbedUnimplementedTristagrammServer()
}

func RegisterTristagrammServer(s grpc.ServiceRegistrar, srv TristagrammServer) {
	s.RegisterService(&Tristagramm_ServiceDesc, srv)
}

func _Tristagramm_GetPostsList_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPostListRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TristagrammServer).GetPostsList(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Tristagramm/GetPostsList",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TristagrammServer).GetPostsList(ctx, req.(*GetPostListRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tristagramm_GetPostsStream_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetPostListRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TristagrammServer).GetPostsStream(m, &tristagrammGetPostsStreamServer{stream})
}

type Tristagramm_GetPostsStreamServer interface {
	Send(*Post) error
	grpc.ServerStream
}

type tristagrammGetPostsStreamServer struct {
	grpc.ServerStream
}

func (x *tristagrammGetPostsStreamServer) Send(m *Post) error {
	return x.ServerStream.SendMsg(m)
}

// Tristagramm_ServiceDesc is the grpc.ServiceDesc for Tristagramm service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Tristagramm_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "Tristagramm",
	HandlerType: (*TristagrammServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetPostsList",
			Handler:    _Tristagramm_GetPostsList_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetPostsStream",
			Handler:       _Tristagramm_GetPostsStream_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "api/grpc/proto/post.proto",
}
